# generic_file.hpp File Reference

class generic_file is defined here as well as class fichier More...

`#include "infinint.hpp"`
`#include "../my_config.h"`
`#include "path.hpp"`
`#include "integers.hpp"`
`#include "user_interaction.hpp"`
`#include "thread_cancellation.hpp"`
`#include <string>`

Go to the source code of this file.

## Classes
class | libdar::generic_file
| this is the interface class from which all other data transfer classes inherit More...
class | libdar::fichier
| this is a full implementation of a generic_file applied to a plain file More...
class | libdar::contextual
| the contextual class adds the information of phases in the generic_file More...
## Namespaces
namespace | libdar
| libdar namespace encapsulate all libdar symbols

## Enumerations
enum | libdar::gf_mode { libdar::gf_read_only, libdar::gf_write_only, libdar::gf_read_write }
| generic_file openning modes More...

## Detailed Description

class generic_file is defined here as well as class fichier

the generic_file interface is widely used in libdar it defines the standard way of transmitting data between different part of the library

- compression engine
- encryption engine
- exchange through pipes
- slicing
- dry run operations
- file access

Definition in file generic_file.hpp.